# ARST打卡第152周[152/521]

<!--more-->

## Algorithm
lc744_寻找比目标字母大的最小字母

直接特判z，然后其他的顺序寻找就行

```cpp
class Solution {
public:
    char nextGreatestLetter(vector<char>& letters, char target) {
        int i = 0;
        int sz = letters.size();
        // if (target == 'z') {
        //     for (i = 0; i < sz; i++) {
        //         if (letters[i] != 'z') {
        //             return letters[i];
        //         }
        //     }
        // }

        for (i = 0; i < sz; i++) {
            if (letters[i] > target) {
                return letters[i];
            }
        }

        // 循环比较直接到这里，返回最前的那个
        return letters[0];
    }
};
```

看题解发现可以直接二分查找，尴尬了


作者：LeetCode-Solution
链接：https://leetcode-cn.com/problems/find-smallest-letter-greater-than-target/solution/xun-zhao-bi-mu-biao-zi-mu-da-de-zui-xiao-lhm7/

```cpp
class Solution {
public:
    char nextGreatestLetter(vector<char> &letters, char target) {
        return target < letters.back() ? *upper_bound(letters.begin(), letters.end() - 1, target) : letters[0];
    }
};
```

## Review
【TED演讲】我们不再信任机构，开始信任陌生人

<div align = "center">
    <iframe  width="100%" height="700" src="//player.bilibili.com/player.html?aid=640255042&bvid=BV1RY4y1p7Qc&cid=566331597&page=1" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
</div>

可以反馈或者是可以记录所有交易过程和评价的系统，让我们对陌生人的信任提升，从而达成交易，从而获得便利

过去是电商交易平台让我们不用再逛街就可信购物，现在是滴滴出行等，未来将会是去中心化的区块链技术

只要可以追溯一个陌生人的所有记录，就可以让单次博弈变成多次博弈，就可以减少信任代价，让世界的交易手续费变得很低，大家都可以获得便利

未来值得期待

## Tips
[C99 designator member outside of aggregate initializer](https://stackoverflow.com/questions/70172941/c99-designator-member-outside-of-aggregate-initializer)

## Share-去中心化存储调研思考
[去中心化存储协议是否能取代中心化云存储？](https://www.163.com/dy/article/GRPVBPDE0519TOTR.html)

[网络类型：PAN、LAN、WLAN、CAN、MAN、SAN和WAN](https://www.cnblogs.com/lawsssscat/p/12825205.html#panpersonal-area-network--%E4%B8%AA%E4%BA%BA%E5%8C%BA%E5%9F%9F%E7%BD%91%E7%BB%9C)


[去中心化存储：Web 3.0 遇见元界](https://cloud.tencent.com/developer/article/1910946)

当然，Filecoin 的商业模式并不完美。需要专业设备，GPU矿机参与。较高的挖矿成本和进入壁垒，使得普通人无法直接提供存储，整个存储网络将被少数巨型存储提供商和大型矿池所占据。IPFS 理想的去中心化存储解决方案在一定程度上再次中心化。

**而且最近俄罗斯和乌克兰战争，导致很多去中心化的系统对俄罗斯的无辜百姓的去中性化资产进行冻结，让我们再次怀疑去中心化**


随着数据安全和用户数据所有权意识的提高，分散存储对于 Web 3.0 和 Metaverse 变得更加重要。去中心化存储在存储来源、带宽来源、安全性、实用性等多个方面与中心化存储不同，这些因素导致目前去中心化存储的规模远小于中心化存储。IPFS 和 Arweave 等项目通过引入不同的激励机制来扩展网络总计算能力，从而克服了去中心化存储的不足。然而，成本结构以及项目团队与用户之间利益不一致等事实阻碍了其快速增长。去中心化存储生态尚处于早期阶段，需要平衡成本、节点数量。

我们期待 Metaverse 和 Web 3.0 中去中心化存储的未来。网络的飞轮效应将推动去中心化存储应用的激增。随着存储技术的改进和激励模型的优化，去中心化存储行业最终将取得重大而稳定的进展。


[web3 wiki](https://zh.wikipedia.org/wiki/Web3)

